﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

namespace MetaClient
{
    public class RoleCustomData
    {
        public Dictionary<int, PartData> bodyList;
        public Dictionary<int, PartData> faceList;
        public Dictionary<string, Vector3> orginLocalScaleList;
        public Dictionary<string, Vector3> orginLocalPositionList;
        public Dictionary<string, Quaternion> orginLocalRotationList;

        public RoleCustomData ()
        {
            bodyList = new Dictionary<int, PartData>();
            faceList = new Dictionary<int, PartData>();
            orginLocalScaleList = new Dictionary<string, Vector3>();
            orginLocalPositionList = new Dictionary<string, Vector3>();
            orginLocalRotationList = new Dictionary<string, Quaternion>();
        }
    }

    public class PartData
    {
        public int id;

        public EditableBodyPart part;

        public ModifyType modifyType;

        public float floatValue;

        public Vector3 vecValue;

        public string pathValue;

        public PartData(int _id,EditableBodyPart _part, ModifyType _modifyType)
        {
            id = _id;
            part = _part;
            modifyType = _modifyType;
            floatValue = 1;
            vecValue = Vector3.zero;
            pathValue = "";
        }
    }
}